#version 330

smooth in vec2 vTexCoord;
smooth in vec3 vNormal;
smooth in vec4 vEyeSpacePos;
smooth in vec3 vWorldPos;

in vec4 ShadowCoord;

out vec4 outputColor;

uniform sampler2D gSampler;
uniform sampler2DShadow shadowMap;
uniform vec4 vColor;


#include "dirLight.frag"
uniform DirectionalLight sunLight;

const vec2 poissonDisk[16] = vec2[]( 
   vec2( -0.94201624, -0.39906216 ), 
   vec2( 0.94558609, -0.76890725 ), 
   vec2( -0.094184101, -0.92938870 ), 
   vec2( 0.34495938, 0.29387760 ), 
   vec2( -0.91588581, 0.45771432 ), 
   vec2( -0.81544232, -0.87912464 ), 
   vec2( -0.38277543, 0.27676845 ), 
   vec2( 0.97484398, 0.75648379 ), 
   vec2( 0.44323325, -0.97511554 ), 
   vec2( 0.53742981, -0.47373420 ), 
   vec2( -0.26496911, -0.41893023 ), 
   vec2( 0.79197514, 0.19090188 ), 
   vec2( -0.24188840, 0.99706507 ), 
   vec2( -0.81409955, 0.91437590 ), 
   vec2( 0.19984126, 0.78641367 ), 
   vec2( 0.14383161, -0.14100790 ) 
);

// Returns a random number based on a vec3 and an int.
float random(vec3 seed, int i){
	vec4 seed4 = vec4(seed,i);
	float dot_product = dot(seed4, vec4(12.9898,78.233,45.164,94.673));
	return fract(sin(dot_product) * 43758.5453);
}

void main(){

	vec3 vNormalized = normalize(vNormal);	
	vec4 vTexColor = texture2D(gSampler, vTexCoord);

	vec4 vMixedColor = vTexColor*vColor;
    vec4 vDirLightColor = GetDirectionalLightColor(sunLight, vNormalized);

	float visibility = 1.0f;
	float bias = 0.5;
	
	for(int i=0; i < 4; i++) {
	 int index = 1;  
	  //int index = int(mod(16.0*random(gl_FragCoord.xyy, i), 16));
	  //int index = int(mod(16.0*random(vWorldPos.xyy, i), 16));
	  //int index = int(16.0*random(floor(ShadowCoord.xyz*1000.0), i))%16;
	 // int index = int(mod(16.0*random(floor(vWorldPos.xyz*1000.0), i),16));
	  visibility -= 0.2*(1.0-texture(shadowMap, vec3(ShadowCoord.xy + poissonDisk[index]/100.0, (ShadowCoord.z-bias)/ShadowCoord.w) ));
	 }  

	/* if (texture(shadowMap, vec3(ShadowCoord.x, ShadowCoord.y, ShadowCoord.z))  <  ShadowCoord.z - bias){
		visibility = 0.5f;
	 }*/

	outputColor = visibility * vMixedColor*vDirLightColor;
}	
	